diff --git a/app/addons/master_products/func.php b/app/addons/master_products/func.php
index ccfb9896508..b3c0d77765a 100644
--- a/app/addons/master_products/func.php
+++ b/app/addons/master_products/func.php
@@ -341,7 +341,7 @@ function fn_master_products_get_products_post(array &$products, array &$params)
         ) {
             [$product['best_product_offer_id'], $best_product_offer_price, $best_product_offer] = fn_master_products_get_best_product_offer($product['product_id']);
 
-            if ($best_product_offer_price === 0) {
+            if ($best_product_offer_price === 0.0) {
                 continue;
             }
 
@@ -941,7 +941,7 @@ function fn_master_products_get_product_data_post(&$product_data, $auth, $previe
 
     [$product_data['best_product_offer_id'], $best_product_offer_price, $best_product_offer] = fn_master_products_get_best_product_offer($product_data['product_id']);
 
-    if ($best_product_offer_price === 0) {
+    if ($best_product_offer_price === 0.0) {
         return;
     }
 
@@ -2078,13 +2078,18 @@ function fn_master_products_get_best_product_offer($master_product_id, array $ve
     $best_product_offer_id = null;
     foreach ($vendor_product_offers as $product) {
         if (
-            !$best_product_offer_id
-            || $vendor_product_offers[$best_product_offer_id]['price'] > $product['price']
+            !empty((float) $product['price'])
+            && (!$best_product_offer_id || $vendor_product_offers[$best_product_offer_id]['price'] > $product['price'])
         ) {
             $best_product_offer_id = $product['product_id'];
         }
     }
 
+    //if all vendor offers with zero price
+    if (!$best_product_offer_id) {
+        $best_product_offer_id = reset($vendor_product_ids);
+    }
+
     $best_product_offer_price = null;
     if (!empty($vendor_product_offers[$best_product_offer_id])) {
         if (
@@ -2107,7 +2112,7 @@ function fn_master_products_get_best_product_offer($master_product_id, array $ve
      */
     fn_set_hook('get_best_product_offer_post', $master_product_id, $best_product_offer_id, $best_product_offer_price, $vendor_product_offers);
 
-    return [(int) $best_product_offer_id, $best_product_offer_price, $vendor_product_offers[$best_product_offer_id]];
+    return [(int) $best_product_offer_id, (float) $best_product_offer_price, $vendor_product_offers[$best_product_offer_id]];
 }
 
 /**
